// Package models provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package models

import (
	"encoding/json"
	"errors"
	"fmt"

	"github.com/oapi-codegen/runtime"
)

// Defines values for ContractState.
const (
	CONTRACTSTATEEXPIRED  ContractState = "CONTRACT_STATE_EXPIRED"
	CONTRACTSTATEPROPOSED ContractState = "CONTRACT_STATE_PROPOSED"
	CONTRACTSTATEREJECTED ContractState = "CONTRACT_STATE_REJECTED"
	CONTRACTSTATEREVOKED  ContractState = "CONTRACT_STATE_REVOKED"
	CONTRACTSTATEVALID    ContractState = "CONTRACT_STATE_VALID"
)

// Defines values for DestinationType.
const (
	TYPEDELEGATEDDESTINATION DestinationType = "TYPE_DELEGATED_DESTINATION"
	TYPEDESTINATION          DestinationType = "TYPE_DESTINATION"
)

// Defines values for DirectionType.
const (
	DIRECTIONINCOMING DirectionType = "DIRECTION_INCOMING"
	DIRECTIONOUTGOING DirectionType = "DIRECTION_OUTGOING"
)

// Defines values for DistributionAction.
const (
	DISTRIBUTIONACTIONSUBMITACCEPTSIGNATURE DistributionAction = "DISTRIBUTION_ACTION_SUBMIT_ACCEPT_SIGNATURE"
	DISTRIBUTIONACTIONSUBMITCONTRACT        DistributionAction = "DISTRIBUTION_ACTION_SUBMIT_CONTRACT"
	DISTRIBUTIONACTIONSUBMITREJECTSIGNATURE DistributionAction = "DISTRIBUTION_ACTION_SUBMIT_REJECT_SIGNATURE"
	DISTRIBUTIONACTIONSUBMITREVOKESIGNATURE DistributionAction = "DISTRIBUTION_ACTION_SUBMIT_REVOKE_SIGNATURE"
)

// Defines values for GrantType.
const (
	GRANTTYPEDELEGATEDSERVICECONNECTION  GrantType = "GRANT_TYPE_DELEGATED_SERVICE_CONNECTION"
	GRANTTYPEDELEGATEDSERVICEPUBLICATION GrantType = "GRANT_TYPE_DELEGATED_SERVICE_PUBLICATION"
	GRANTTYPESERVICECONNECTION           GrantType = "GRANT_TYPE_SERVICE_CONNECTION"
	GRANTTYPESERVICEPUBLICATION          GrantType = "GRANT_TYPE_SERVICE_PUBLICATION"
)

// Defines values for HashAlgorithm.
const (
	HASHALGORITHMSHA3512 HashAlgorithm = "HASH_ALGORITHM_SHA3_512"
)

// Defines values for PeerRole.
const (
	PEERROLEDIRECTORY PeerRole = "PEER_ROLE_DIRECTORY"
)

// Defines values for Protocol.
const (
	PROTOCOLTCPHTTP11 Protocol = "PROTOCOL_TCP_HTTP_1.1"
	PROTOCOLTCPHTTP2  Protocol = "PROTOCOL_TCP_HTTP_2"
)

// Defines values for ServiceType.
const (
	SERVICETYPEDELEGATEDSERVICE ServiceType = "SERVICE_TYPE_DELEGATED_SERVICE"
	SERVICETYPESERVICE          ServiceType = "SERVICE_TYPE_SERVICE"
)

// Defines values for SortOrder.
const (
	SORTORDERASCENDING  SortOrder = "SORT_ORDER_ASCENDING"
	SORTORDERDESCENDING SortOrder = "SORT_ORDER_DESCENDING"
)

// Defines values for SourceType.
const (
	TYPEDELEGATEDSOURCE SourceType = "TYPE_DELEGATED_SOURCE"
	TYPESOURCE          SourceType = "TYPE_SOURCE"
)

// Connection A connection between two Peers
type Connection struct {
	// ContractHash The hash of the Content of a Contract
	ContractHash ContentHash `json:"contract_hash"`

	// CreatedAt A Unix timestamp
	CreatedAt Timestamp `json:"created_at"`

	// DelegatorPeerId The ID of a Peer
	DelegatorPeerId *PeerID `json:"delegator_peer_id,omitempty"`

	// GrantHash The hash of a Grant
	GrantHash GrantHash `json:"grant_hash"`

	// NotAfter A Unix timestamp
	NotAfter Timestamp `json:"not_after"`

	// NotBefore A Unix timestamp
	NotBefore Timestamp `json:"not_before"`

	// OutwayPeerId The ID of a Peer
	OutwayPeerId PeerID `json:"outway_peer_id"`

	// OutwayPublicKeyThumbprint The SHA256 thumbprint of the Public Key used in the certificate of the Outway for requesting Tokens in HEX-encoded format
	OutwayPublicKeyThumbprint PublicKeyThumbprint `json:"outway_public_key_thumbprint"`

	// ServiceName The name of a service
	ServiceName ServiceName `json:"service_name"`

	// ServicePeerId The ID of a Peer
	ServicePeerId PeerID `json:"service_peer_id"`

	// ServicePublicationDelegatorPeerId The ID of a Peer
	ServicePublicationDelegatorPeerId *PeerID `json:"service_publication_delegator_peer_id,omitempty"`

	// State The state of a Contract
	State *ContractState `json:"state,omitempty"`
}

// ContentHash The hash of the Content of a Contract
type ContentHash = string

// Contract A Contract
type Contract struct {
	// Content The content of a Contract
	Content ContractContent `json:"content"`

	// HasAccepted true if peer has accepted the contract
	HasAccepted bool `json:"has_accepted"`

	// HasRejected true if peer has rejected the contract
	HasRejected bool `json:"has_rejected"`

	// HasRevoked true if peer has revoked the contract
	HasRevoked bool `json:"has_revoked"`

	// Hash The hash of the Content of a Contract
	Hash ContentHash `json:"hash"`

	// Peers A list of PeerIDs present on the Contract
	Peers []PeerID `json:"peers"`

	// Signatures The accept, reject and revoke signatures
	Signatures Signatures `json:"signatures"`

	// State The state of a Contract
	State ContractState `json:"state"`
}

// ContractContent The content of a Contract
type ContractContent struct {
	// CreatedAt A Unix timestamp
	CreatedAt Timestamp `json:"created_at"`

	// Grants The Grants of the Contract
	Grants []Grant `json:"grants"`

	// GroupId The FSC Group ID (Directory URI)
	GroupId string `json:"group_id"`

	// HashAlgorithm The hashing algorithm
	HashAlgorithm HashAlgorithm `json:"hash_algorithm"`

	// Iv The IV of the Contract. UUID version 7
	Iv       string   `json:"iv"`
	Validity Validity `json:"validity"`
}

// ContractDistribution A distribution of a Contract. A distribution is a failed attempt to distribute an action of a Contract. For the possible actions please refer to  '#/components/schemas/distributionAction'
type ContractDistribution struct {
	// Action The type action of a Contract distribution
	Action DistributionAction `json:"action"`

	// Attempts The number of times the distribution has been attempted
	Attempts int `json:"attempts"`

	// ContractHash The hash of the Content of a Contract
	ContractHash ContentHash `json:"contract_hash"`

	// LastAttemptAt A Unix timestamp
	LastAttemptAt Timestamp `json:"lastAttemptAt"`

	// NextAttemptAt A Unix timestamp
	NextAttemptAt *Timestamp `json:"nextAttemptAt,omitempty"`

	// PeerId The ID of a Peer
	PeerId PeerID `json:"peer_id"`

	// Reason The error message of the last attempt
	Reason string `json:"reason"`

	// Signature The Base64 URL encoded JWS of the signature.
	Signature string `json:"signature"`
}

// ContractState The state of a Contract
type ContractState string

// DelegatedService defines model for delegatedService.
type DelegatedService struct {
	Delegator Peer `json:"delegator"`

	// Name The name of a service
	Name ServiceName `json:"name"`
	Peer Peer        `json:"peer"`
	Type ServiceType `json:"type"`
}

// DelegatorPeer The details of a Delegator
type DelegatorPeer struct {
	// PeerId The ID of a Peer
	PeerId PeerID `json:"peer_id"`
}

// Destination Details of the Peer offering the Service
type Destination struct {
	// ServicePeerId The ID of a Peer
	ServicePeerId PeerID          `json:"service_peer_id"`
	Type          DestinationType `json:"type"`
}

// DestinationDelegated Details of the Peer offering the Service and the Delegator
type DestinationDelegated struct {
	// DelegatorPeerId The ID of a Peer
	DelegatorPeerId PeerID `json:"delegator_peer_id"`

	// ServicePeerId The ID of a Peer
	ServicePeerId PeerID          `json:"service_peer_id"`
	Type          DestinationType `json:"type"`
}

// DestinationType defines model for destinationType.
type DestinationType string

// DirectionType The direction of a request. I.e. is the request being send or received
type DirectionType string

// DirectoryPeer The details of the Directory
type DirectoryPeer struct {
	// PeerId The ID of a Peer
	PeerId PeerID `json:"peer_id"`
}

// DistributionAction The type action of a Contract distribution
type DistributionAction string

// Error Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type Error struct {
	// Details Human-readable explanation specific to this occurrence of the problem.
	// The "detail" string, if present, ought to focus on helping the client correct the problem, rather than giving debugging information.
	Details string `json:"details"`

	// Instance URI reference that identifies the specific occurrence of the problem.
	Instance string `json:"instance"`

	// Status HTTP status code generated by the origin server for this occurrence of the problem.
	Status int `json:"status"`

	// Title Short, human-readable summary of the problem type.
	Title string `json:"title"`

	// Type URI reference that identifies the problem type.
	Type string `json:"type"`
}

// Grant defines model for grant.
type Grant struct {
	union json.RawMessage
}

// GrantDelegatedServiceConnection A DelegatedServiceConnectionGrant
type GrantDelegatedServiceConnection struct {
	// Delegator The details of a Delegator
	Delegator DelegatorPeer `json:"delegator"`

	// Hash The hash of a Grant
	Hash GrantHash `json:"hash"`

	// Outway The details of the Outway for which a connection authorization was granted
	Outway  OutwayPeer                              `json:"outway"`
	Service GrantDelegatedServiceConnection_Service `json:"service"`

	// Type The type of Grant
	Type GrantType `json:"type"`
}

// GrantDelegatedServiceConnection_Service defines model for GrantDelegatedServiceConnection.Service.
type GrantDelegatedServiceConnection_Service struct {
	union json.RawMessage
}

// GrantDelegatedServicePublication A DelegatedServicePublicationGrant
type GrantDelegatedServicePublication struct {
	// Delegator The details of a Delegator
	Delegator DelegatorPeer `json:"delegator"`

	// Directory The details of the Directory
	Directory DirectoryPeer `json:"directory"`

	// Hash The hash of a Grant
	Hash GrantHash `json:"hash"`

	// Service The details of a Service publication
	Service ServicePublication `json:"service"`

	// Type The type of Grant
	Type GrantType `json:"type"`
}

// GrantHash The hash of a Grant
type GrantHash = string

// GrantServiceConnection A ServiceConnectionGrant
type GrantServiceConnection struct {
	// Hash The hash of a Grant
	Hash GrantHash `json:"hash"`

	// Outway The details of the Outway for which a connection authorization was granted
	Outway  OutwayPeer                     `json:"outway"`
	Service GrantServiceConnection_Service `json:"service"`

	// Type The type of Grant
	Type GrantType `json:"type"`
}

// GrantServiceConnection_Service defines model for GrantServiceConnection.Service.
type GrantServiceConnection_Service struct {
	union json.RawMessage
}

// GrantServicePublication A ServicePublicationGrant
type GrantServicePublication struct {
	// Directory The details of the Directory
	Directory DirectoryPeer `json:"directory"`

	// Hash The hash of a Grant
	Hash GrantHash `json:"hash"`

	// Service The details of a Service publication
	Service ServicePublication `json:"service"`

	// Type The type of Grant
	Type GrantType `json:"type"`
}

// GrantType The type of Grant
type GrantType string

// HashAlgorithm The hashing algorithm
type HashAlgorithm string

// LogRecord A log record
type LogRecord struct {
	// CreatedAt A Unix timestamp
	CreatedAt   Timestamp             `json:"created_at"`
	Destination LogRecord_Destination `json:"destination"`

	// Direction The direction of a request. I.e. is the request being send or received
	Direction DirectionType `json:"direction"`

	// GrantHash The hash of a Grant
	GrantHash GrantHash `json:"grant_hash"`

	// ServiceName The name of a service
	ServiceName ServiceName      `json:"service_name"`
	Source      LogRecord_Source `json:"source"`

	// TransactionId UUID v7
	TransactionId Uuid `json:"transaction_id"`
}

// LogRecord_Destination defines model for LogRecord.Destination.
type LogRecord_Destination struct {
	union json.RawMessage
}

// LogRecord_Source defines model for LogRecord.Source.
type LogRecord_Source struct {
	union json.RawMessage
}

// ManagerAddress Address of the manager
type ManagerAddress = string

// Metadata defines model for metadata.
type Metadata struct {
	// Direction The direction of a request. I.e. is the request being send or received
	Direction DirectionType `json:"direction"`

	// TransactionId UUID v7
	TransactionId        Uuid                              `json:"transaction_id"`
	AdditionalProperties map[string]map[string]interface{} `json:"-"`
}

// OutwayPeer The details of the Outway for which a connection authorization was granted
type OutwayPeer struct {
	// PeerId The ID of a Peer
	PeerId PeerID `json:"peer_id"`

	// PublicKeyThumbprint The SHA256 thumbprint of the Public Key used in the certificate of the Outway for requesting Tokens in HEX-encoded format
	PublicKeyThumbprint PublicKeyThumbprint `json:"public_key_thumbprint"`
}

// OutwayService Outway service
type OutwayService struct {
	// Name The name of a service
	Name ServiceName `json:"name"`

	// PeerId The ID of a Peer
	PeerId PeerID `json:"peer_id"`
}

// OutwayServices Map of Grant hashes and Services
type OutwayServices map[string]OutwayService

// PaginationResult defines model for paginationResult.
type PaginationResult struct {
	// NextCursor A cursor that can be used to retrieve the next page or an empty string if there are no more results
	NextCursor string `json:"next_cursor"`
}

// Peer defines model for peer.
type Peer struct {
	// Id The ID of a Peer
	Id PeerID `json:"id"`

	// ManagerAddress Address of the manager
	ManagerAddress ManagerAddress `json:"manager_address"`

	// Name The name of a Peer
	Name  PeerName   `json:"name"`
	Roles []PeerRole `json:"roles"`
}

// PeerID The ID of a Peer
type PeerID = string

// PeerName The name of a Peer
type PeerName = string

// PeerRole defines model for peerRole.
type PeerRole string

// PeerSynchronizationResult defines model for peerSynchronizationResult.
type PeerSynchronizationResult struct {
	// Error Contains an error in case the synchronization failed
	Error *string `json:"error,omitempty"`

	// Ok True if synchronization succeeded.
	Ok bool `json:"ok"`

	// PeerId The ID of a Peer
	PeerId PeerID `json:"peer_id"`
}

// PendingContract A contract that requires an action
type PendingContract struct {
	// Grants The Grants of the Contract
	Grants []Grant `json:"grants"`

	// Hash The hash of the Content of a Contract
	Hash ContentHash `json:"hash"`

	// ValidNotBefore A Unix timestamp
	ValidNotBefore Timestamp `json:"valid_not_before"`
}

// Protocol application layer protocol supported
type Protocol string

// PublicKeyThumbprint The SHA256 thumbprint of the Public Key used in the certificate of the Outway for requesting Tokens in HEX-encoded format
type PublicKeyThumbprint = string

// Publication defines model for publication.
type Publication struct {
	// ContractHash The hash of the Content of a Contract
	ContractHash ContentHash `json:"contract_hash"`

	// CreatedAt A Unix timestamp
	CreatedAt Timestamp `json:"created_at"`

	// DelegatorPeerId The ID of a Peer
	DelegatorPeerId *PeerID `json:"delegator_peer_id,omitempty"`

	// DirectoryPeerId The ID of a Peer
	DirectoryPeerId PeerID `json:"directory_peer_id"`

	// GrantHash The hash of a Grant
	GrantHash GrantHash `json:"grant_hash"`

	// NotAfter A Unix timestamp
	NotAfter Timestamp `json:"not_after"`

	// NotBefore A Unix timestamp
	NotBefore Timestamp `json:"not_before"`

	// ServiceName The name of a service
	ServiceName ServiceName `json:"service_name"`

	// ServicePeerId The ID of a Peer
	ServicePeerId PeerID `json:"service_peer_id"`

	// State The state of a Contract
	State *ContractState `json:"state,omitempty"`
}

// Publications List of active service publication and delegated service publication grants
type Publications = []Publication

// Service defines model for service.
type Service struct {
	// Name The name of a service
	Name ServiceName `json:"name"`
	Peer Peer        `json:"peer"`
	Type ServiceType `json:"type"`
}

// ServiceListing defines model for serviceListing.
type ServiceListing struct {
	union json.RawMessage
}

// ServiceName The name of a service
type ServiceName = string

// ServicePublication The details of a Service publication
type ServicePublication struct {
	// Name The name of a service
	Name ServiceName `json:"name"`

	// PeerId The ID of a Peer
	PeerId PeerID `json:"peer_id"`

	// Protocol application layer protocol supported
	Protocol Protocol `json:"protocol"`
}

// ServiceType defines model for serviceType.
type ServiceType string

// Services defines model for services.
type Services = []ServiceListing

// Signature Signature of a Peer
type Signature struct {
	Peer Peer `json:"peer"`

	// SignedAt A Unix timestamp
	SignedAt Timestamp `json:"signed_at"`
}

// SignatureMap Map of PeerIDs and signatures
type SignatureMap map[string]Signature

// Signatures The accept, reject and revoke signatures
type Signatures struct {
	// Accept Map of PeerIDs and signatures
	Accept SignatureMap `json:"accept"`

	// Reject Map of PeerIDs and signatures
	Reject SignatureMap `json:"reject"`

	// Revoke Map of PeerIDs and signatures
	Revoke SignatureMap `json:"revoke"`
}

// SortOrder The order in which the results should be returned
type SortOrder string

// Source Details of the Peer initiating the request
type Source struct {
	// OutwayPeerId The ID of a Peer
	OutwayPeerId PeerID     `json:"outway_peer_id"`
	Type         SourceType `json:"type"`
}

// SourceDelegated Details of the Peer initiating the request and the Delegator
type SourceDelegated struct {
	// DelegatorPeerId The ID of a Peer
	DelegatorPeerId PeerID `json:"delegator_peer_id"`

	// OutwayPeerId The ID of a Peer
	OutwayPeerId PeerID     `json:"outway_peer_id"`
	Type         SourceType `json:"type"`
}

// SourceType defines model for sourceType.
type SourceType string

// Timestamp A Unix timestamp
type Timestamp = int64

// Uuid UUID v7
type Uuid = string

// Validity defines model for validity.
type Validity struct {
	// NotAfter A Unix timestamp
	NotAfter Timestamp `json:"not_after"`

	// NotBefore A Unix timestamp
	NotBefore Timestamp `json:"not_before"`
}

// CorrelationID UUID v7
type CorrelationID = Uuid

// PathContractHash The hash of the Content of a Contract
type PathContractHash = ContentHash

// PathDirectoryPeerID The ID of a Peer
type PathDirectoryPeerID = PeerID

// PathDistributionAction The type action of a Contract distribution
type PathDistributionAction = DistributionAction

// PathPeerID The ID of a Peer
type PathPeerID = PeerID

// QueryContractStates defines model for queryContractStates.
type QueryContractStates = []ContractState

// QueryIncludeCount defines model for queryIncludeCount.
type QueryIncludeCount = bool

// QueryPaginationCursor defines model for queryPaginationCursor.
type QueryPaginationCursor = string

// QueryPaginationLimit defines model for queryPaginationLimit.
type QueryPaginationLimit = uint32

// QueryPaginationOrder The order in which the results should be returned
type QueryPaginationOrder = SortOrder

// QueryServiceNames defines model for queryServiceNames.
type QueryServiceNames = []ServiceName

// N400BadRequest Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N400BadRequest = Error

// N401Unauthorized Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N401Unauthorized = Error

// N403Forbidden Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N403Forbidden = Error

// N404NotFound Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N404NotFound = Error

// N408RequestTimeout Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N408RequestTimeout = Error

// N413PayloadTooLarge Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N413PayloadTooLarge = Error

// N414URITooLong Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N414URITooLong = Error

// N422UnprocessableEntity Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N422UnprocessableEntity = Error

// N429TooManyRequests Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N429TooManyRequests = Error

// N431RequestHeaderFieldsTooLarge Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N431RequestHeaderFieldsTooLarge = Error

// N500InternalServerError Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N500InternalServerError = Error

// N503ServiceUnavailable Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N503ServiceUnavailable = Error

// N505HTTPVersionNotSupported Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N505HTTPVersionNotSupported = Error

// ListDelegatedConnectionsParams defines parameters for ListDelegatedConnections.
type ListDelegatedConnectionsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page. Base64 encoded string of two properties: a created_at as unix timestamp and a content hash separated by a comma. Eg. `base64(1672527600,$1$1$+PQI7we01qIfEwq4O5UioLKzjGBgRva6F5+bUfDlKxUjcY5yX1MRsn6NKquDbL8VcklhYO9sk18rHD6La3w/mg)
	Cursor *QueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *QueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// IncludeCount If true includes the total found rows
	IncludeCount *QueryIncludeCount `form:"include_count,omitempty" json:"include_count,omitempty"`

	// ContractStates only return results where the underlying Contract has at least one of these states
	ContractStates *QueryContractStates `form:"contract_states,omitempty" json:"contract_states,omitempty"`
}

// ListIncomingConnectionsParams defines parameters for ListIncomingConnections.
type ListIncomingConnectionsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page. Base64 encoded string of two properties: a created_at as unix timestamp and a content hash separated by a comma. Eg. `base64(1672527600,$1$1$+PQI7we01qIfEwq4O5UioLKzjGBgRva6F5+bUfDlKxUjcY5yX1MRsn6NKquDbL8VcklhYO9sk18rHD6La3w/mg)
	Cursor *QueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *QueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// IncludeCount If true includes the total found rows
	IncludeCount *QueryIncludeCount `form:"include_count,omitempty" json:"include_count,omitempty"`

	// ContractStates only return results where the underlying Contract has at least one of these states
	ContractStates *QueryContractStates `form:"contract_states,omitempty" json:"contract_states,omitempty"`

	// ServiceNames A list of Service names on which to filter. The pagination parameter will be ignored when this filter is set.
	ServiceNames *QueryServiceNames `form:"service_names,omitempty" json:"service_names,omitempty"`
}

// ListOutgoingConnectionsParams defines parameters for ListOutgoingConnections.
type ListOutgoingConnectionsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page. Base64 encoded string of two properties: a created_at as unix timestamp and a content hash separated by a comma. Eg. `base64(1672527600,$1$1$+PQI7we01qIfEwq4O5UioLKzjGBgRva6F5+bUfDlKxUjcY5yX1MRsn6NKquDbL8VcklhYO9sk18rHD6La3w/mg)
	Cursor *QueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *QueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// IncludeCount If true includes the total found rows
	IncludeCount *QueryIncludeCount `form:"include_count,omitempty" json:"include_count,omitempty"`

	// ContractStates only return results where the underlying Contract has at least one of these states
	ContractStates *QueryContractStates `form:"contract_states,omitempty" json:"contract_states,omitempty"`
}

// ListOutgoingConnectionsForServiceParams defines parameters for ListOutgoingConnectionsForService.
type ListOutgoingConnectionsForServiceParams struct {
	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`
}

// ListOutgoingConnectionsForDelegatedServiceParams defines parameters for ListOutgoingConnectionsForDelegatedService.
type ListOutgoingConnectionsForDelegatedServiceParams struct {
	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`
}

// GetContractsParams defines parameters for GetContracts.
type GetContractsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page. Base64 encoded string of two properties: a created_at as unix timestamp and a content hash separated by a comma. Eg. `base64(1672527600,$1$1$+PQI7we01qIfEwq4O5UioLKzjGBgRva6F5+bUfDlKxUjcY5yX1MRsn6NKquDbL8VcklhYO9sk18rHD6La3w/mg)
	Cursor *QueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *QueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// GrantType A Grant type on which to filter. Returns Contracts which contain a Grant of the Grant Type specified in the grant_type filter
	GrantType *[]GrantType `form:"grant_type,omitempty" json:"grant_type,omitempty"`

	// ContentHash A list of Content hashes on which to filter. Returns Contracts with content hash that matches one of the content hashes specified
	ContentHash *[]ContentHash `form:"content_hash,omitempty" json:"content_hash,omitempty"`

	// GrantHash A list of Grant hashes on which to filter. Returns Contracts with grant hash that matches one of the grant hashes specified
	GrantHash *[]GrantHash `form:"grant_hash,omitempty" json:"grant_hash,omitempty"`
}

// CreateContractJSONBody defines parameters for CreateContract.
type CreateContractJSONBody struct {
	// ContractContent The content of a Contract
	ContractContent ContractContent `json:"contract_content"`
}

// CreateContractParams defines parameters for CreateContract.
type CreateContractParams struct {
	// AuditlogCorrelationId Optional correlation ID so that multiple auditlog records in different
	// components can be linked together
	AuditlogCorrelationId *CorrelationID `json:"Auditlog-Correlation-Id,omitempty"`
}

// ListPendingContractsParams defines parameters for ListPendingContracts.
type ListPendingContractsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page. Base64 encoded string of two properties: a created_at as unix timestamp and a content hash separated by a comma. Eg. `base64(1672527600,$1$1$+PQI7we01qIfEwq4O5UioLKzjGBgRva6F5+bUfDlKxUjcY5yX1MRsn6NKquDbL8VcklhYO9sk18rHD6La3w/mg)
	Cursor *QueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *QueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// IncludeCount If true includes the total found rows
	IncludeCount *QueryIncludeCount `form:"include_count,omitempty" json:"include_count,omitempty"`
}

// AcceptContractParams defines parameters for AcceptContract.
type AcceptContractParams struct {
	// AuditlogCorrelationId Optional correlation ID so that multiple auditlog records in different
	// components can be linked together
	AuditlogCorrelationId *CorrelationID `json:"Auditlog-Correlation-Id,omitempty"`
}

// RetryContractDistributionParams defines parameters for RetryContractDistribution.
type RetryContractDistributionParams struct {
	// AuditlogCorrelationId Optional correlation ID so that multiple auditlog records in different
	// components can be linked together
	AuditlogCorrelationId *CorrelationID `json:"Auditlog-Correlation-Id,omitempty"`
}

// RejectContractParams defines parameters for RejectContract.
type RejectContractParams struct {
	// AuditlogCorrelationId Optional correlation ID so that multiple auditlog records in different
	// components can be linked together
	AuditlogCorrelationId *CorrelationID `json:"Auditlog-Correlation-Id,omitempty"`
}

// RevokeContractParams defines parameters for RevokeContract.
type RevokeContractParams struct {
	// AuditlogCorrelationId Optional correlation ID so that multiple auditlog records in different
	// components can be linked together
	AuditlogCorrelationId *CorrelationID `json:"Auditlog-Correlation-Id,omitempty"`
}

// ListDelegatedServicePublicationsParams defines parameters for ListDelegatedServicePublications.
type ListDelegatedServicePublicationsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page. Base64 encoded string of two properties: a created_at as unix timestamp and a content hash separated by a comma. Eg. `base64(1672527600,$1$1$+PQI7we01qIfEwq4O5UioLKzjGBgRva6F5+bUfDlKxUjcY5yX1MRsn6NKquDbL8VcklhYO9sk18rHD6La3w/mg)
	Cursor *QueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *QueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// IncludeCount If true includes the total found rows
	IncludeCount *QueryIncludeCount `form:"include_count,omitempty" json:"include_count,omitempty"`

	// ContractStates only return results where the underlying Contract has at least one of these states
	ContractStates *QueryContractStates `form:"contract_states,omitempty" json:"contract_states,omitempty"`
}

// GetLogsParams defines parameters for GetLogs.
type GetLogsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page. Base64 encoded string of two properties: a created_at as unix timestamp and a content hash separated by a comma. Eg. `base64(1672527600,$1$1$+PQI7we01qIfEwq4O5UioLKzjGBgRva6F5+bUfDlKxUjcY5yX1MRsn6NKquDbL8VcklhYO9sk18rHD6La3w/mg)
	Cursor *QueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *QueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// After Log records with a creation date after this value will be returned
	After *Timestamp `form:"after,omitempty" json:"after,omitempty"`

	// Before Log records with a creation date before this value will be returned
	Before *Timestamp `form:"before,omitempty" json:"before,omitempty"`

	// DataSourcePeerId Get the log records from this peer. If empty the source will be our own log record DB
	DataSourcePeerId *PeerID `form:"data_source_peer_id,omitempty" json:"data_source_peer_id,omitempty"`

	// GrantHash A list of Grant hashes on which to filter
	GrantHash *[]GrantHash `form:"grant_hash,omitempty" json:"grant_hash,omitempty"`

	// ServiceName A list of service names on which to filter
	ServiceName *[]ServiceName `form:"service_name,omitempty" json:"service_name,omitempty"`

	// TransactionId A list of transaction IDs on which to filter
	TransactionId *[]Uuid `form:"transaction_id,omitempty" json:"transaction_id,omitempty"`

	// PeerId A list of peer IDs on which to filter
	PeerId *[]PeerID `form:"peer_id,omitempty" json:"peer_id,omitempty"`
}

// ListPeersParams defines parameters for ListPeers.
type ListPeersParams struct {
	// PeerIds A list of Peer IDs on which to filter. Returns Peers with an Peerd ID that matches one of the Peer IDs specified
	PeerIds *[]PeerID `form:"peer_ids,omitempty" json:"peer_ids,omitempty"`
}

// CreatePeerJSONBody defines parameters for CreatePeer.
type CreatePeerJSONBody struct {
	Peer Peer `json:"peer"`
}

// CreatePeerParams defines parameters for CreatePeer.
type CreatePeerParams struct {
	// AuditlogCorrelationId Optional correlation ID so that multiple auditlog records in different
	// components can be linked together
	AuditlogCorrelationId *CorrelationID `json:"Auditlog-Correlation-Id,omitempty"`
}

// UpdatePeerJSONBody defines parameters for UpdatePeer.
type UpdatePeerJSONBody struct {
	Peer Peer `json:"peer"`
}

// UpdatePeerParams defines parameters for UpdatePeer.
type UpdatePeerParams struct {
	// AuditlogCorrelationId Optional correlation ID so that multiple auditlog records in different
	// components can be linked together
	AuditlogCorrelationId *CorrelationID `json:"Auditlog-Correlation-Id,omitempty"`
}

// ListServicesParams defines parameters for ListServices.
type ListServicesParams struct {
	// PeerId A Peer ID on which to filter. Returns Services offered by the Peer defined in the PeerID filter.
	PeerId *PeerID `form:"peer_id,omitempty" json:"peer_id,omitempty"`
}

// ListServicePublicationsParams defines parameters for ListServicePublications.
type ListServicePublicationsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page. Base64 encoded string of two properties: a created_at as unix timestamp and a content hash separated by a comma. Eg. `base64(1672527600,$1$1$+PQI7we01qIfEwq4O5UioLKzjGBgRva6F5+bUfDlKxUjcY5yX1MRsn6NKquDbL8VcklhYO9sk18rHD6La3w/mg)
	Cursor *QueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *QueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// IncludeCount If true includes the total found rows
	IncludeCount *QueryIncludeCount `form:"include_count,omitempty" json:"include_count,omitempty"`

	// ContractStates only return results where the underlying Contract has at least one of these states
	ContractStates *QueryContractStates `form:"contract_states,omitempty" json:"contract_states,omitempty"`

	// ServiceNames A list of Service names on which to filter. The pagination parameter will be ignored when this filter is set.
	ServiceNames *QueryServiceNames `form:"service_names,omitempty" json:"service_names,omitempty"`
}

// CreateContractJSONRequestBody defines body for CreateContract for application/json ContentType.
type CreateContractJSONRequestBody CreateContractJSONBody

// CreatePeerJSONRequestBody defines body for CreatePeer for application/json ContentType.
type CreatePeerJSONRequestBody CreatePeerJSONBody

// UpdatePeerJSONRequestBody defines body for UpdatePeer for application/json ContentType.
type UpdatePeerJSONRequestBody UpdatePeerJSONBody

// Getter for additional properties for Metadata. Returns the specified
// element and whether it was found
func (a Metadata) Get(fieldName string) (value map[string]interface{}, found bool) {
	if a.AdditionalProperties != nil {
		value, found = a.AdditionalProperties[fieldName]
	}
	return
}

// Setter for additional properties for Metadata
func (a *Metadata) Set(fieldName string, value map[string]interface{}) {
	if a.AdditionalProperties == nil {
		a.AdditionalProperties = make(map[string]map[string]interface{})
	}
	a.AdditionalProperties[fieldName] = value
}

// Override default JSON handling for Metadata to handle AdditionalProperties
func (a *Metadata) UnmarshalJSON(b []byte) error {
	object := make(map[string]json.RawMessage)
	err := json.Unmarshal(b, &object)
	if err != nil {
		return err
	}

	if raw, found := object["direction"]; found {
		err = json.Unmarshal(raw, &a.Direction)
		if err != nil {
			return fmt.Errorf("error reading 'direction': %w", err)
		}
		delete(object, "direction")
	}

	if raw, found := object["transaction_id"]; found {
		err = json.Unmarshal(raw, &a.TransactionId)
		if err != nil {
			return fmt.Errorf("error reading 'transaction_id': %w", err)
		}
		delete(object, "transaction_id")
	}

	if len(object) != 0 {
		a.AdditionalProperties = make(map[string]map[string]interface{})
		for fieldName, fieldBuf := range object {
			var fieldVal map[string]interface{}
			err := json.Unmarshal(fieldBuf, &fieldVal)
			if err != nil {
				return fmt.Errorf("error unmarshaling field %s: %w", fieldName, err)
			}
			a.AdditionalProperties[fieldName] = fieldVal
		}
	}
	return nil
}

// Override default JSON handling for Metadata to handle AdditionalProperties
func (a Metadata) MarshalJSON() ([]byte, error) {
	var err error
	object := make(map[string]json.RawMessage)

	object["direction"], err = json.Marshal(a.Direction)
	if err != nil {
		return nil, fmt.Errorf("error marshaling 'direction': %w", err)
	}

	object["transaction_id"], err = json.Marshal(a.TransactionId)
	if err != nil {
		return nil, fmt.Errorf("error marshaling 'transaction_id': %w", err)
	}

	for fieldName, field := range a.AdditionalProperties {
		object[fieldName], err = json.Marshal(field)
		if err != nil {
			return nil, fmt.Errorf("error marshaling '%s': %w", fieldName, err)
		}
	}
	return json.Marshal(object)
}

// AsGrantServicePublication returns the union data inside the Grant as a GrantServicePublication
func (t Grant) AsGrantServicePublication() (GrantServicePublication, error) {
	var body GrantServicePublication
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromGrantServicePublication overwrites any union data inside the Grant as the provided GrantServicePublication
func (t *Grant) FromGrantServicePublication(v GrantServicePublication) error {
	v.Type = "GRANT_TYPE_SERVICE_PUBLICATION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeGrantServicePublication performs a merge with any union data inside the Grant, using the provided GrantServicePublication
func (t *Grant) MergeGrantServicePublication(v GrantServicePublication) error {
	v.Type = "GRANT_TYPE_SERVICE_PUBLICATION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsGrantServiceConnection returns the union data inside the Grant as a GrantServiceConnection
func (t Grant) AsGrantServiceConnection() (GrantServiceConnection, error) {
	var body GrantServiceConnection
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromGrantServiceConnection overwrites any union data inside the Grant as the provided GrantServiceConnection
func (t *Grant) FromGrantServiceConnection(v GrantServiceConnection) error {
	v.Type = "GRANT_TYPE_SERVICE_CONNECTION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeGrantServiceConnection performs a merge with any union data inside the Grant, using the provided GrantServiceConnection
func (t *Grant) MergeGrantServiceConnection(v GrantServiceConnection) error {
	v.Type = "GRANT_TYPE_SERVICE_CONNECTION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsGrantDelegatedServiceConnection returns the union data inside the Grant as a GrantDelegatedServiceConnection
func (t Grant) AsGrantDelegatedServiceConnection() (GrantDelegatedServiceConnection, error) {
	var body GrantDelegatedServiceConnection
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromGrantDelegatedServiceConnection overwrites any union data inside the Grant as the provided GrantDelegatedServiceConnection
func (t *Grant) FromGrantDelegatedServiceConnection(v GrantDelegatedServiceConnection) error {
	v.Type = "GRANT_TYPE_DELEGATED_SERVICE_CONNECTION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeGrantDelegatedServiceConnection performs a merge with any union data inside the Grant, using the provided GrantDelegatedServiceConnection
func (t *Grant) MergeGrantDelegatedServiceConnection(v GrantDelegatedServiceConnection) error {
	v.Type = "GRANT_TYPE_DELEGATED_SERVICE_CONNECTION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsGrantDelegatedServicePublication returns the union data inside the Grant as a GrantDelegatedServicePublication
func (t Grant) AsGrantDelegatedServicePublication() (GrantDelegatedServicePublication, error) {
	var body GrantDelegatedServicePublication
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromGrantDelegatedServicePublication overwrites any union data inside the Grant as the provided GrantDelegatedServicePublication
func (t *Grant) FromGrantDelegatedServicePublication(v GrantDelegatedServicePublication) error {
	v.Type = "GRANT_TYPE_DELEGATED_SERVICE_PUBLICATION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeGrantDelegatedServicePublication performs a merge with any union data inside the Grant, using the provided GrantDelegatedServicePublication
func (t *Grant) MergeGrantDelegatedServicePublication(v GrantDelegatedServicePublication) error {
	v.Type = "GRANT_TYPE_DELEGATED_SERVICE_PUBLICATION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t Grant) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t Grant) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "GRANT_TYPE_DELEGATED_SERVICE_CONNECTION":
		return t.AsGrantDelegatedServiceConnection()
	case "GRANT_TYPE_DELEGATED_SERVICE_PUBLICATION":
		return t.AsGrantDelegatedServicePublication()
	case "GRANT_TYPE_SERVICE_CONNECTION":
		return t.AsGrantServiceConnection()
	case "GRANT_TYPE_SERVICE_PUBLICATION":
		return t.AsGrantServicePublication()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t Grant) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Grant) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsService returns the union data inside the GrantDelegatedServiceConnection_Service as a Service
func (t GrantDelegatedServiceConnection_Service) AsService() (Service, error) {
	var body Service
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromService overwrites any union data inside the GrantDelegatedServiceConnection_Service as the provided Service
func (t *GrantDelegatedServiceConnection_Service) FromService(v Service) error {
	v.Type = "SERVICE_TYPE_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeService performs a merge with any union data inside the GrantDelegatedServiceConnection_Service, using the provided Service
func (t *GrantDelegatedServiceConnection_Service) MergeService(v Service) error {
	v.Type = "SERVICE_TYPE_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsDelegatedService returns the union data inside the GrantDelegatedServiceConnection_Service as a DelegatedService
func (t GrantDelegatedServiceConnection_Service) AsDelegatedService() (DelegatedService, error) {
	var body DelegatedService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDelegatedService overwrites any union data inside the GrantDelegatedServiceConnection_Service as the provided DelegatedService
func (t *GrantDelegatedServiceConnection_Service) FromDelegatedService(v DelegatedService) error {
	v.Type = "SERVICE_TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDelegatedService performs a merge with any union data inside the GrantDelegatedServiceConnection_Service, using the provided DelegatedService
func (t *GrantDelegatedServiceConnection_Service) MergeDelegatedService(v DelegatedService) error {
	v.Type = "SERVICE_TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t GrantDelegatedServiceConnection_Service) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t GrantDelegatedServiceConnection_Service) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "SERVICE_TYPE_DELEGATED_SERVICE":
		return t.AsDelegatedService()
	case "SERVICE_TYPE_SERVICE":
		return t.AsService()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t GrantDelegatedServiceConnection_Service) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *GrantDelegatedServiceConnection_Service) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsService returns the union data inside the GrantServiceConnection_Service as a Service
func (t GrantServiceConnection_Service) AsService() (Service, error) {
	var body Service
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromService overwrites any union data inside the GrantServiceConnection_Service as the provided Service
func (t *GrantServiceConnection_Service) FromService(v Service) error {
	v.Type = "SERVICE_TYPE_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeService performs a merge with any union data inside the GrantServiceConnection_Service, using the provided Service
func (t *GrantServiceConnection_Service) MergeService(v Service) error {
	v.Type = "SERVICE_TYPE_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsDelegatedService returns the union data inside the GrantServiceConnection_Service as a DelegatedService
func (t GrantServiceConnection_Service) AsDelegatedService() (DelegatedService, error) {
	var body DelegatedService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDelegatedService overwrites any union data inside the GrantServiceConnection_Service as the provided DelegatedService
func (t *GrantServiceConnection_Service) FromDelegatedService(v DelegatedService) error {
	v.Type = "SERVICE_TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDelegatedService performs a merge with any union data inside the GrantServiceConnection_Service, using the provided DelegatedService
func (t *GrantServiceConnection_Service) MergeDelegatedService(v DelegatedService) error {
	v.Type = "SERVICE_TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t GrantServiceConnection_Service) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t GrantServiceConnection_Service) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "SERVICE_TYPE_DELEGATED_SERVICE":
		return t.AsDelegatedService()
	case "SERVICE_TYPE_SERVICE":
		return t.AsService()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t GrantServiceConnection_Service) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *GrantServiceConnection_Service) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsDestination returns the union data inside the LogRecord_Destination as a Destination
func (t LogRecord_Destination) AsDestination() (Destination, error) {
	var body Destination
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDestination overwrites any union data inside the LogRecord_Destination as the provided Destination
func (t *LogRecord_Destination) FromDestination(v Destination) error {
	v.Type = "DESTINATION_TYPE_DESTINATION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDestination performs a merge with any union data inside the LogRecord_Destination, using the provided Destination
func (t *LogRecord_Destination) MergeDestination(v Destination) error {
	v.Type = "DESTINATION_TYPE_DESTINATION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsDestinationDelegated returns the union data inside the LogRecord_Destination as a DestinationDelegated
func (t LogRecord_Destination) AsDestinationDelegated() (DestinationDelegated, error) {
	var body DestinationDelegated
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDestinationDelegated overwrites any union data inside the LogRecord_Destination as the provided DestinationDelegated
func (t *LogRecord_Destination) FromDestinationDelegated(v DestinationDelegated) error {
	v.Type = "DESTINATION_TYPE_DELEGATED_DESTINATION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDestinationDelegated performs a merge with any union data inside the LogRecord_Destination, using the provided DestinationDelegated
func (t *LogRecord_Destination) MergeDestinationDelegated(v DestinationDelegated) error {
	v.Type = "DESTINATION_TYPE_DELEGATED_DESTINATION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t LogRecord_Destination) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t LogRecord_Destination) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "DESTINATION_TYPE_DELEGATED_DESTINATION":
		return t.AsDestinationDelegated()
	case "DESTINATION_TYPE_DESTINATION":
		return t.AsDestination()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t LogRecord_Destination) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *LogRecord_Destination) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsSource returns the union data inside the LogRecord_Source as a Source
func (t LogRecord_Source) AsSource() (Source, error) {
	var body Source
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromSource overwrites any union data inside the LogRecord_Source as the provided Source
func (t *LogRecord_Source) FromSource(v Source) error {
	v.Type = "SOURCE_TYPE_SOURCE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeSource performs a merge with any union data inside the LogRecord_Source, using the provided Source
func (t *LogRecord_Source) MergeSource(v Source) error {
	v.Type = "SOURCE_TYPE_SOURCE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsSourceDelegated returns the union data inside the LogRecord_Source as a SourceDelegated
func (t LogRecord_Source) AsSourceDelegated() (SourceDelegated, error) {
	var body SourceDelegated
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromSourceDelegated overwrites any union data inside the LogRecord_Source as the provided SourceDelegated
func (t *LogRecord_Source) FromSourceDelegated(v SourceDelegated) error {
	v.Type = "SOURCE_TYPE_DELEGATED_SOURCE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeSourceDelegated performs a merge with any union data inside the LogRecord_Source, using the provided SourceDelegated
func (t *LogRecord_Source) MergeSourceDelegated(v SourceDelegated) error {
	v.Type = "SOURCE_TYPE_DELEGATED_SOURCE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t LogRecord_Source) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t LogRecord_Source) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "SOURCE_TYPE_DELEGATED_SOURCE":
		return t.AsSourceDelegated()
	case "SOURCE_TYPE_SOURCE":
		return t.AsSource()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t LogRecord_Source) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *LogRecord_Source) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsService returns the union data inside the ServiceListing as a Service
func (t ServiceListing) AsService() (Service, error) {
	var body Service
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromService overwrites any union data inside the ServiceListing as the provided Service
func (t *ServiceListing) FromService(v Service) error {
	v.Type = "SERVICE_TYPE_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeService performs a merge with any union data inside the ServiceListing, using the provided Service
func (t *ServiceListing) MergeService(v Service) error {
	v.Type = "SERVICE_TYPE_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsDelegatedService returns the union data inside the ServiceListing as a DelegatedService
func (t ServiceListing) AsDelegatedService() (DelegatedService, error) {
	var body DelegatedService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromDelegatedService overwrites any union data inside the ServiceListing as the provided DelegatedService
func (t *ServiceListing) FromDelegatedService(v DelegatedService) error {
	v.Type = "SERVICE_TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeDelegatedService performs a merge with any union data inside the ServiceListing, using the provided DelegatedService
func (t *ServiceListing) MergeDelegatedService(v DelegatedService) error {
	v.Type = "SERVICE_TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t ServiceListing) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t ServiceListing) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "SERVICE_TYPE_DELEGATED_SERVICE":
		return t.AsDelegatedService()
	case "SERVICE_TYPE_SERVICE":
		return t.AsService()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t ServiceListing) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *ServiceListing) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}
